(* Exmaple of Acyclic communication: 
WRITE :register address index 502 (6 byte Write)/ (5 Byte read)
library AsNxPnM
*)
PROGRAM _INIT
	device := 'SS1.IF1';
	name := 'opde';
	slot := 0;
	subslot := 1;   
	index := 502;   // opde Profinet Index register
	Data[0]:= 16#01;// Modbus request to the node 0x01
	Data[1]:= 16#06;// Read Holding Registers (0x03) / Write Holding Registers (0x06)
	Data[2]:= 16#00;// Hi part [starting from register 0x00b0 (176+1=  p177) 
	Data[3]:= 16#b0;// Lo part  ----------]
	Data[4]:= 16#06;// Value: 0x06ab (1707d)
	Data[5]:= 16#ab;// If reading (0x03) indicate num of registers 
	
	// GetHandle block  used to read the device handle of a NetX Profinet slave
	nxpnmGetHandle_SDO.enable := TRUE; //
	nxpnmGetHandle_SDO.pDevice := ADR(device);
	nxpnmGetHandle_SDO.pName := ADR(name);
	
	nxpnmGetHandle_SDO;
	
END_PROGRAM

PROGRAM _CYCLIC

	nxpnmAcyclicWrite_SDO.enable := WriteExe;
	nxpnmAcyclicWrite_SDO.pDevice := ADR(device);
	nxpnmAcyclicWrite_SDO.handle := nxpnmGetHandle_SDO.handle;
	nxpnmAcyclicWrite_SDO.api := 0;
	nxpnmAcyclicWrite_SDO.slot := slot;
	nxpnmAcyclicWrite_SDO.subslot := subslot;
	nxpnmAcyclicWrite_SDO.index := index;
	nxpnmAcyclicWrite_SDO.dataLength := 6;
	nxpnmAcyclicWrite_SDO.pData := ADR(Data);
	
	nxpnmAcyclicWrite_SDO;
	
	nxpnmAcyclicRead_SDO.enable := ReadExe;
	nxpnmAcyclicRead_SDO.pDevice := ADR(device);
	nxpnmAcyclicRead_SDO.handle := nxpnmGetHandle_SDO.handle;
	nxpnmAcyclicRead_SDO.api := 0;
	nxpnmAcyclicRead_SDO.slot := slot;
	nxpnmAcyclicRead_SDO.subslot := subslot;
	nxpnmAcyclicRead_SDO.index := index;
	nxpnmAcyclicRead_SDO.dataLengthMax := 8;
	nxpnmAcyclicRead_SDO.pData := ADR(DataRead);
	
	nxpnmAcyclicRead_SDO;
	
END_PROGRAM

PROGRAM _EXIT
	(* Insert code here *)
	 
END_PROGRAM

